"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var classnames_1 = require("classnames");
var core_1 = require("./core");
var Transition_1 = require("../util/Transition");
var Carousel = /** @class */ (function (_super) {
    __extends(Carousel, _super);
    function Carousel() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.root = React.createRef();
        _this._oldPath = '';
        _this.size = { width: 0, height: 0 };
        return _this;
    }
    Carousel.prototype.render = function () {
        var _a = this.props, path = _a.path, manager = _a.manager;
        if (!path)
            return null;
        var _b = this.props, getComponent = _b.children, transitionDuration = _b.transitionDuration, comp = getComponent(path), reverse = manager.getDirection(this._oldPath, path).reverse, getClassName = function (action) {
            var className = {
                WillEnter: 'enter',
                Leave: 'leave',
                Enter: 'stay',
                WillLeave: 'stay'
            }[action] || '';
            if (reverse) {
                className = {
                    'enter': 'leave', 'leave': 'enter'
                }[className] || className;
            }
            return className;
        };
        var body = (manager.skipAnimation.indexOf(path) != -1) ? React.createElement("div", null, comp) :
            React.createElement(Transition_1.Transition, { transitionDuration: transitionDuration, getClassName: getClassName, component: comp });
        this._oldPath = path;
        return (React.createElement("div", { className: classnames_1.default('srCarousel', this.props.className), ref: this.root }, body));
    };
    Carousel.prototype.readSize = function () {
        var rootDiv = this.root.current;
        if (rootDiv) {
            var _a = rootDiv.getBoundingClientRect(), width = _a.width, height = _a.height;
            this.size.width = width;
            this.size.height = height;
        }
    };
    Carousel.prototype.componentDidUpdate = function () {
        this.readSize();
    };
    Carousel.prototype.componentDidMount = function () {
        this.readSize();
    };
    Carousel = __decorate([
        core_1.withManager,
        core_1.withPath
    ], Carousel);
    return Carousel;
}(React.PureComponent));
exports.Carousel = Carousel;
//# sourceMappingURL=Carousel.js.map