"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var classnames_1 = require("classnames");
var core_1 = require("./core");
var Folder = /** @class */ (function (_super) {
    __extends(Folder, _super);
    function Folder() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            show: false,
            action: '',
            props: null,
            firstRender: true,
            mounted: false
        };
        _this.timers = [];
        return _this;
    }
    Folder.getDerivedStateFromProps = function (props, state) {
        //no need to handle them 
        if (!state.mounted || props == state.props)
            return state;
        var test = props.test, path = props.path, show = core_1.match(path, test);
        if (show !== state.show) {
            var action = show ? 'WillEnter' : 'WillLeave';
            if (state.firstRender)
                action = '';
            return {
                show: true, action: action, props: props,
                firstRender: false
            };
        }
        return __assign({}, state, { firstRender: false });
    };
    Folder.prototype.render = function () {
        var _a = this.props, path = _a.path, manager = _a.manager, transitionDuration = _a.transitionDuration;
        if (!path)
            return null;
        var _b = this.state, action = _b.action, show = _b.show;
        var content = this.props.children;
        var clsName = {
            WillEnter: 'leave',
            Leave: 'leave',
            Enter: 'stay',
            WillLeave: 'stay'
        }[action] || '';
        return (React.createElement("div", { className: classnames_1.default('srFolder', this.props.className, clsName, { hidden: !show }), style: {
                transitionDuration: (this.props.transitionDuration) + 'ms'
            } }, content));
    };
    Folder.prototype.clearTimer = function () {
        var timers = this.timers;
        if (timers.length) {
            timers.forEach(function (t) { return clearTimeout(t); });
            timers.length = 0;
        }
        return timers;
    };
    Folder.prototype.componentDidUpdate = function () {
        var _this = this;
        var action = this.state.action;
        if (action.startsWith('Will')) {
            var timers = this.clearTimer();
            timers.push(setTimeout(function () {
                _this.setState({ action: action.replace('Will', '') });
            }, 10));
            timers.push(setTimeout(function () {
                _this.setState({
                    action: '',
                    show: !action.endsWith('Leave')
                });
            }, this.props.transitionDuration));
        }
    };
    Folder.prototype.componentDidMount = function () {
        this.state.mounted = true;
    };
    Folder.prototype.componentWillUnmount = function () {
        this.state.mounted = false;
    };
    Folder.defaultProps = {
        transitionDuration: 300
    };
    Folder = __decorate([
        core_1.withManager,
        core_1.withPath
    ], Folder);
    return Folder;
}(React.PureComponent));
exports.Folder = Folder;
//# sourceMappingURL=Folder.js.map