"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var core_1 = require("./core");
var History_1 = require("./History");
require("./Router.scss");
var defaultManager = {
    history: new History_1.HashHistory,
    getDirection: function (oldPath, newPath) {
        function parts(str) {
            return str.split('/').length;
        }
        function last(str) {
            return str.split('/').pop();
        }
        var reverse = (parts(oldPath) > parts(newPath))
            || (last(oldPath) > last(newPath));
        return {
            reverse: reverse
        };
    },
    redirects: {},
    skipAnimation: []
};
var Router = /** @class */ (function (_super) {
    __extends(Router, _super);
    function Router() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            path: ''
        };
        _this.manager = Object.assign({}, defaultManager, _this.props.manager);
        _this.onHistoryChange = function (path) {
            _this.setState({
                path: window.location.hash.replace('#', '')
            });
        };
        return _this;
    }
    //manager.history.redirects = manager.redirects
    Router.prototype.render = function () {
        var manager = this.manager;
        manager.history.redirects = manager.redirects;
        return React.createElement(core_1.ManagerProvier, { value: manager },
            React.createElement(core_1.PathProvier, { value: this.state.path }, this.props.children));
    };
    Object.defineProperty(Router.prototype, "history", {
        get: function () {
            return this.manager.history;
        },
        enumerable: true,
        configurable: true
    });
    Router.prototype.componentDidMount = function () {
        var history = this.history;
        history.addHandler(this.onHistoryChange).fire();
    };
    Router.prototype.componentWillUnmount = function () {
        this.manager.history.removeHandler(this.onHistoryChange);
    };
    return Router;
}(React.PureComponent));
exports.Router = Router;
//# sourceMappingURL=Router.js.map