"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
if (!String.prototype.startsWith) {
    String.prototype.startsWith = function (searchString, position) {
        position = position || 0;
        return this.indexOf(searchString, position) === position;
    };
}
var _a = React.createContext(''), PathProvier = _a.Provider, PathConsumer = _a.Consumer;
exports.PathProvier = PathProvier;
var _b = React.createContext(null), ManagerProvier = _b.Provider, ManagerConsumer = _b.Consumer;
exports.ManagerProvier = ManagerProvier;
function withPath(Component) {
    return function (props) {
        return (React.createElement(PathConsumer, null, function (value) { return React.createElement(Component, __assign({}, props, { path: value })); }));
    };
}
exports.withPath = withPath;
function withManager(Component) {
    return function (props) {
        return (React.createElement(ManagerConsumer, null, function (value) { return React.createElement(Component, __assign({}, props, { manager: value })); }));
    };
}
exports.withManager = withManager;
function isFunction(functionToCheck) {
    return functionToCheck && {}.toString.call(functionToCheck) === '[object Function]';
}
/**
 * return true|false for a path and a test
 * @param path
 * @param test
 */
function match(path, test) {
    var match = false;
    if (test instanceof RegExp) {
        match = test.test(path);
    }
    else if (isFunction(test)) {
        match = test(path);
    }
    else {
        match = path.startsWith(test);
    }
    return match;
}
exports.match = match;
//# sourceMappingURL=core.js.map