"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
require("./polyfill");
//const effect = createTag('Effect') as Tag
/** effects handles side effects/async tasks, the method needs to be async  */
function effect(target, key, desc) {
    target[key]['isEffect'] = true;
}
exports.effect = effect;
function singleEffect(target, key, desc) {
    target[key]['isEffect'] = true;
    target[key]['singleEffect'] = true;
}
exports.singleEffect = singleEffect;
/** computed fields can be used in 'connect', it output values based on state  */
function computed(target, key, desc) {
    target[key]['isComputed'] = true;
}
exports.computed = computed;
/** tag a method a middleware, can only be used on method of a Plugin class  */
function middleware(target, key, desc) {
    target[key]['isMiddleware'] = true;
}
exports.middleware = middleware;
/**
 * Model class provides helper methods like getSibling.
 * It's not mandatory for a model to extend this class, unless it needs those methods
 */
var Model = /** @class */ (function () {
    function Model() {
    }
    /**
     * fetch sibling model for reading its state or calling its reducer/effect
     * @param modelId
     */
    Model.prototype.importModel = function (Class) {
        return null;
    };
    Model.prototype.events = function () {
        return null;
    };
    /** trigged when model is installed  */
    Model.prototype.onModelInstalled = function (storeSore, dispatch, modelId) { };
    return Model;
}());
exports.Model = Model;
/**
 * Implement Plugin to provide common functions like logging, displaying loading bar
 * Plugin class doesn't provide any extra function than Model class, at the moment
 */
var Plugin = /** @class */ (function (_super) {
    __extends(Plugin, _super);
    function Plugin() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._isPlugin_ = true;
        return _this;
    }
    return Plugin;
}(Model));
exports.Plugin = Plugin;
/**
 * the UI Events handls small user interaction, like alert or prompt.
 * service store contains a single events.
 */
var UIEvents = /** @class */ (function () {
    function UIEvents() {
        this.pool = {};
        this.observers = [];
    }
    UIEvents.prototype.run = function (onStart, onFinish) {
        var _this = this;
        var pool = this.pool, id = this.createUniqId();
        return new Promise(function (resolve) {
            onStart(id);
            pool[id] = function (ret) {
                if (onFinish)
                    onFinish(ret);
                resolve(ret);
            };
            _this.notify();
        });
    };
    UIEvents.prototype.createUniqId = function () {
        return (Date.now().toString(36) +
            Math.random()
                .toString(36)
                .substr(2, 5)).toUpperCase();
    };
    UIEvents.prototype.solve = function (pid, ret) {
        var solve = this.pool[pid];
        solve(ret);
        delete this.pool[pid];
        this.notify();
    };
    Object.defineProperty(UIEvents.prototype, "count", {
        get: function () {
            return Object.keys(this.pool).length;
        },
        enumerable: true,
        configurable: true
    });
    UIEvents.prototype.notify = function () {
        var _this = this;
        this.observers.forEach(function (ob) { return ob(_this); });
    };
    UIEvents.prototype.addObserver = function (ob) {
        this.observers.push(ob);
    };
    return UIEvents;
}());
exports.UIEvents = UIEvents;
//# sourceMappingURL=core.js.map