"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("../core");
var LoadingUI_1 = require("./ui/LoadingUI");
/* built in models */
/**
 * for showing loading status
 */
var Loading = /** @class */ (function (_super) {
    __extends(Loading, _super);
    function Loading() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.current = {};
        _this.uiSessionCount = 0;
        return _this;
    }
    Loading.prototype.count = function () {
        var current = this.current;
        return Object.keys(current).reduce(function (count, key) { return count + current[key]; }, 0);
    };
    Loading.prototype.addAction = function (actionType) {
        this.current[actionType] = (this.current[actionType] || 0) + 1;
    };
    Loading.prototype.removeAction = function (actionType) {
        this.current[actionType] = this.current[actionType] - 1;
    };
    Loading.prototype.clearAll = function () {
        this.current = {};
    };
    Loading.prototype.onDispatch = function (ctx, info) {
        var isEffect = info.isEffect, isEffectFinish = info.isEffectFinish, type = info.type, serviceStore = info.serviceStore;
        if (serviceStore.effects.length == 0 && this.count() > 0) {
            //force clear all
            this.clearAll();
            return;
        }
        if (isEffect) {
            if (isEffectFinish) {
                this.removeAction(type);
            }
            else {
                this.addAction(type);
            }
        }
    };
    Loading.prototype.setUiSessionCount = function (count) {
        this.uiSessionCount = count;
    };
    Loading.prototype.onModelInstalled = function (store, dispatch, modelId) {
        var events = store.events;
        events.addObserver(function (ob) { return dispatch.setUiSessionCount(ob.count); });
        store.pluginUIs.push(LoadingUI_1.createUI(store));
    };
    __decorate([
        core_1.computed,
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], Loading.prototype, "count", null);
    __decorate([
        core_1.middleware,
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object, Object]),
        __metadata("design:returntype", void 0)
    ], Loading.prototype, "onDispatch", null);
    return Loading;
}(core_1.Plugin));
exports.Loading = Loading;
//# sourceMappingURL=Loading.js.map