"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("../core");
var Logging = /** @class */ (function (_super) {
    __extends(Logging, _super);
    function Logging(cfg) {
        var _this = _super.call(this) || this;
        _this._privateFields_ = ['effectPool', 'log', 'filter'];
        _this.effectPool = {};
        Object.assign(_this, cfg);
        return _this;
    }
    Logging.prototype.log = function (type, payload, state, queue) {
        var modelId = type.split('/')[0];
        if (state[modelId])
            state = state[modelId];
        console.groupCollapsed(type);
        console.log('payload:', payload);
        if (!queue) {
            console.log('state:', state);
        }
        else if (queue.length) {
            console.groupCollapsed('reducers:' + queue.map(function (q) { return q.type; }).join(','));
            queue.forEach(function (q) {
                console.group(q.type + ' start at ' + q.time);
                console.log('payload:', q.payload);
                console.log('state:', q.state);
                console.groupEnd();
            });
            console.groupEnd();
            console.log('state:', state);
        }
        console.groupEnd();
    };
    Logging.prototype.filter = function (ctx, mCtx) {
        return true;
    };
    Logging.prototype.onDispatch = function (ctx, info) {
        var _a = info.model, log = _a.log, filter = _a.filter, effectPool = _a.effectPool, type = info.type, isPluginAction = info.isPluginAction, isEffect = info.isEffect, isEffectFinish = info.isEffectFinish, effectRootId = info.effectRootId, action = ctx.action, next = ctx.next, store = ctx.store, modelId = type.split('/')[0], result = next(action); //to finish effect first 
        if (!isPluginAction && filter(ctx, info)) {
            var state = store.getState()[modelId], _b = action, payload = _b.payload, effectId = _b.effectId;
            if (effectId) {
                var isRoot = (effectId == effectRootId);
                //console.log(type + '=' + effectId + ',' + effectRootId)
                if (!effectPool[effectId]) {
                    effectPool[effectId] = { start: Date.now(), queue: [], payload: payload };
                }
                var _c = effectPool[effectId], queue = _c.queue, start = _c.start, time = Date.now() - start + 'ms';
                if (isEffectFinish && isRoot) { //take out and log when effect finishes 
                    //console.log('-----------aaa')
                    if (type == queue[0].type) {
                        var first = queue.shift();
                        log(type + " (total:" + time + ")", first.payload, state, queue);
                        delete effectPool[effectId];
                    }
                }
                else {
                    var record = { type: type, time: time, payload: payload, state: state, isEffect: isEffect };
                    if (!queue.some(function (q) { return q.isEffect; })) {
                        queue.unshift(record);
                    }
                    else {
                        queue.push(record);
                    }
                }
            }
            else {
                log(type, payload, state);
            }
        }
        return result === undefined ? null : result;
    };
    __decorate([
        core_1.middleware,
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object, Object]),
        __metadata("design:returntype", void 0)
    ], Logging.prototype, "onDispatch", null);
    return Logging;
}(core_1.Plugin));
exports.Logging = Logging;
//# sourceMappingURL=Logging.js.map