"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var Tools_1 = require("../Tools");
var classnames_1 = require("classnames");
require("./ToolsUI.scss");
var ServiceStore_1 = require("../../ServiceStore");
var ToolsUI = /** @class */ (function (_super) {
    __extends(ToolsUI, _super);
    function ToolsUI() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ToolsUI.prototype.render = function () {
        var _a = this.props, dialogs = _a.dialogs, progress = _a.progress, dialogsEle = (dialogs && dialogs.length) ?
            dialogs.map(function (config, i) { return (React.createElement(Dialog, { config: config, key: 'dialog_' + config.id })); }) : null, progressEle = (progress && progress.percentage > 0) ?
            React.createElement(Progress, { config: progress, key: 'progress' }) : null;
        return React.createElement("div", { className: 'ToolsUI' },
            dialogsEle,
            progressEle);
    };
    return ToolsUI;
}(React.PureComponent));
var Dialog = /** @class */ (function (_super) {
    __extends(Dialog, _super);
    function Dialog() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.btnClick = function (idx) {
            var _a = _this.props, events = _a.events, config = _a.config;
            events.solve(config.id, idx);
        };
        return _this;
    }
    Dialog.prototype.render = function () {
        var _this = this;
        var _a = this.props, config = _a.config, className = _a.className, title = config.title, message = config.message;
        var buttons = config.buttons || ['OK'];
        return React.createElement("div", { className: 'container' },
            React.createElement("div", { className: classnames_1.default("Dialog", className) },
                (title) ? React.createElement("div", { className: 'header' }, title) : null,
                React.createElement("div", { className: 'content' }, message),
                React.createElement("div", { className: 'actions' }, buttons.map(function (b, i) { return React.createElement("button", { key: b, onClick: function () {
                        _this.btnClick(i);
                    } }, b); }))),
            React.createElement("div", { className: "DialogMask" }));
    };
    Dialog = __decorate([
        ServiceStore_1.withUIEvents
    ], Dialog);
    return Dialog;
}(React.Component));
var Progress = /** @class */ (function (_super) {
    __extends(Progress, _super);
    function Progress() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Progress.prototype.render = function () {
        var _a = this.props, events = _a.events, config = _a.config, percentage = config.percentage, message = config.message, label = parseInt(percentage) + '%', barStyle = { width: label };
        return React.createElement("div", { className: 'container' },
            React.createElement("div", { className: "Dialog Progress" },
                React.createElement("div", { className: 'content' }, message),
                React.createElement("div", { className: 'bar meter' },
                    React.createElement("span", { style: barStyle }, percentage <= 100 ? label : ''))),
            React.createElement("div", { className: "DialogMask" }));
    };
    Progress = __decorate([
        ServiceStore_1.withUIEvents
    ], Progress);
    return Progress;
}(React.Component));
function createUI(store) {
    var connect = store.connect, modelId = store.getModelIdByClass(Tools_1.Tools);
    return connect(function (s) {
        var tools = s[modelId];
        return {
            dialogs: tools.dialogs,
            progress: tools.progress
        };
    })(ToolsUI);
}
exports.createUI = createUI;
//# sourceMappingURL=ToolsUI.js.map