function __$styleInject (css, returnValue) {
  if (typeof document === 'undefined') {
    return returnValue;
  }
  css = css || '';
  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';
  head.appendChild(style);
  
  if (style.styleSheet){
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
  return returnValue;
}

import { createContext, createElement, Children, Fragment, PureComponent, Component, createRef, cloneElement } from 'react';
import classnames from 'classnames';
import produce from 'immer';
import { createStore, combineReducers, compose, applyMiddleware } from 'redux';
import { connect, Provider } from 'react-redux';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}

function __metadata(metadataKey, metadataValue) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
}

function __awaiter(thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

if (!String.prototype.startsWith) {
    String.prototype.startsWith = function (searchString, position) {
        position = position || 0;
        return this.indexOf(searchString, position) === position;
    };
}
var _a = createContext(''), PathProvier = _a.Provider, PathConsumer = _a.Consumer;
var _b = createContext(null), ManagerProvier = _b.Provider, ManagerConsumer = _b.Consumer;
function withPath(Component$$1) {
    return function (props) {
        return (createElement(PathConsumer, null, function (value) { return createElement(Component$$1, __assign({}, props, { path: value })); }));
    };
}
function withManager(Component$$1) {
    return function (props) {
        return (createElement(ManagerConsumer, null, function (value) { return createElement(Component$$1, __assign({}, props, { manager: value })); }));
    };
}
function isFunction(functionToCheck) {
    return functionToCheck && {}.toString.call(functionToCheck) === '[object Function]';
}
/**
 * return true|false for a path and a test
 * @param path
 * @param test
 */
function match(path, test) {
    var match = false;
    if (test instanceof RegExp) {
        match = test.test(path);
    }
    else if (isFunction(test)) {
        match = test(path);
    }
    else {
        match = path.startsWith(test);
    }
    return match;
}

/**
 * display or hide child component based on test
 */
var Route = /** @class */ (function (_super) {
    __extends(Route, _super);
    function Route() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Route.prototype.render = function () {
        var _a = this.props, path = _a.path, test = _a.test, show = match(path, test);
        return show ? this.props.children : null;
    };
    Route = __decorate([
        withPath
    ], Route);
    return Route;
}(PureComponent));

var Link = /** @class */ (function (_super) {
    __extends(Link, _super);
    function Link() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.click = function () {
            var _a = _this.props, manager = _a.manager, to = _a.to;
            manager.history.push(to);
        };
        return _this;
    }
    Link.prototype.render = function () {
        return createElement("a", { onClick: this.click, className: classnames('srLink', {
                active: this.isActive()
            }) },
            " ",
            this.props.children,
            "  ");
    };
    Link.prototype.isActive = function () {
        var path = this.props.path, test = this.props.test || this.props.to;
        return match(path, test);
    };
    Link = __decorate([
        withManager,
        withPath
    ], Link);
    return Link;
}(PureComponent));

function removeFirst(str, toRemove) {
    if (str.indexOf(toRemove) == 0) {
        return str.replace(toRemove, '');
    }
    else {
        return str;
    }
}
var HashHistory = /** @class */ (function () {
    function HashHistory() {
        var _this = this;
        this.handlers = [];
        this.onChange = function () {
            var path = _this.current;
            //console.log('p=', path)
            var redirect = _this.redirects[path];
            if (redirect) {
                _this.replace(redirect);
            }
            else {
                _this.handlers.forEach(function (h) { return h(path); });
            }
        };
        this.redirects = {};
    }
    Object.defineProperty(HashHistory.prototype, "current", {
        get: function () {
            return removeFirst(window.location.hash, '#');
        },
        enumerable: true,
        configurable: true
    });
    HashHistory.prototype.push = function (path) {
        window.location.hash = path;
    };
    HashHistory.prototype.replace = function (path) {
        var href = window.location.href, hashIndex = href.indexOf("#"), newURL = href.slice(0, hashIndex >= 0 ? hashIndex : 0) + "#" + path;
        window.location.replace(newURL);
    };
    HashHistory.prototype.go = function (change) {
        window.history.go(change);
    };
    HashHistory.prototype.goBack = function () {
        this.go(-1);
    };
    HashHistory.prototype.goForward = function () {
        this.go(1);
    };
    HashHistory.prototype.handlerChanged = function () {
        window.removeEventListener('hashchange', this.onChange);
        if (this.handlers.length > 0) {
            window.addEventListener('hashchange', this.onChange);
        }
    };
    HashHistory.prototype.addHandler = function (handler) {
        this.handlers.push(handler);
        this.handlerChanged();
        return this;
    };
    HashHistory.prototype.removeHandler = function (handler) {
        this.handlers = this.handlers.filter(function (h) { return h != handler; });
        this.handlerChanged();
        return this;
    };
    HashHistory.prototype.fire = function () {
        this.onChange();
    };
    return HashHistory;
}());

__$styleInject(".srLink {\n  background-color: white;\n  cursor: default;\n  user-select: none; }\n\n.srLink:active {\n  background-color: silver; }\n\n.srLink.active {\n  outline: 2px solid black; }\n\n.srCarousel {\n  flex-grow: 1;\n  font-size: 50px;\n  position: relative;\n  overflow: hidden;\n  min-height: 200px; }\n  .srCarousel > div {\n    position: absolute;\n    transition: left  2s;\n    box-sizing: border-box;\n    width: 100%;\n    height: 100%; }\n    .srCarousel > div.stay {\n      left: 0; }\n    .srCarousel > div.enter {\n      left: 100%; }\n    .srCarousel > div.leave {\n      left: -100%; }\n\n.srFolder {\n  transition: max-width  .3s;\n  overflow: hidden; }\n  .srFolder.hidden {\n    display: none; }\n  .srFolder.stay {\n    max-width: 200px; }\n  .srFolder.leave {\n    max-width: 0; }\n\n.loader-wrapper {\n  position: fixed;\n  top: 0;\n  left: 0;\n  width: 100%;\n  height: 100%;\n  z-index: 90;\n  pointer-events: none; }\n  .loader-wrapper > .loader {\n    position: relative;\n    left: 50%;\n    top: 50%;\n    border: 8px solid #f3f3f3;\n    /* Light grey */\n    border-top: 8px solid #3498db;\n    /* Blue */\n    border-radius: 50%;\n    width: 40px;\n    height: 40px;\n    margin-left: -20px;\n    margin-top: -20px;\n    animation: loaderSpin .8s linear infinite; }\n\n@keyframes loaderSpin {\n  0% {\n    transform: rotate(0deg); }\n  100% {\n    transform: rotate(360deg); } }\n\n.ToolsUI {\n  font-size: 14px; }\n  .ToolsUI > .container {\n    position: fixed;\n    left: 0;\n    top: 0;\n    display: flex;\n    align-items: center;\n    justify-content: center;\n    height: 100vh;\n    width: 100vw;\n    z-index: 100; }\n    .ToolsUI > .container > .Dialog {\n      border: 1px solid silver;\n      min-width: 30%;\n      min-height: 100px;\n      box-shadow: 1px 3px 3px 0 rgba(0, 0, 0, 0.2), 1px 3px 15px 2px rgba(0, 0, 0, 0.2);\n      display: flex;\n      flex-flow: column;\n      border-radius: .2rem;\n      z-index: 101;\n      background-color: white; }\n      .ToolsUI > .container > .Dialog.WillEnter {\n        transition: opacity .2s;\n        opacity: 0; }\n      .ToolsUI > .container > .Dialog.Enter {\n        transition: opacity .2s;\n        opacity: 1; }\n      .ToolsUI > .container > .Dialog > .header {\n        padding: 1.25rem 1.5rem;\n        font-size: 1.3em;\n        border-bottom: 1px solid rgba(34, 36, 38, 0.15); }\n      .ToolsUI > .container > .Dialog > .content {\n        flex-grow: 1;\n        padding: 1.25rem 1.5rem; }\n      .ToolsUI > .container > .Dialog > .actions {\n        text-align: right;\n        background-color: #f9fafb;\n        border-top: 1px solid rgba(34, 36, 38, 0.15); }\n        .ToolsUI > .container > .Dialog > .actions > button {\n          font-weight: 700;\n          margin: 1rem;\n          margin-left: 0;\n          padding: .8em 1.5em .7em;\n          border-radius: .2rem;\n          border: 1px solid silver;\n          background-color: white;\n          color: gray;\n          user-select: none; }\n          .ToolsUI > .container > .Dialog > .actions > button:hover {\n            background-color: rgba(0, 0, 0, 0.02);\n            box-shadow: 1px 1px 1px 0 rgba(0, 0, 0, 0.05); }\n          .ToolsUI > .container > .Dialog > .actions > button:first-child {\n            background-color: #2185d0;\n            border-color: #2185d0;\n            color: white;\n            margin-left: 1rem; }\n            .ToolsUI > .container > .Dialog > .actions > button:first-child:hover {\n              background-color: #136db3; }\n      .ToolsUI > .container > .Dialog.Progress {\n        min-height: 0; }\n        .ToolsUI > .container > .Dialog.Progress > .content {\n          padding: 1em; }\n        .ToolsUI > .container > .Dialog.Progress > .bar {\n          background-color: rgba(0, 0, 0, 0.1);\n          height: 2em;\n          border-radius: .2rem;\n          margin: 1em;\n          margin-top: -1em;\n          overflow: hidden;\n          padding: 0; }\n          .ToolsUI > .container > .Dialog.Progress > .bar > span {\n            line-height: 2em;\n            text-align: right;\n            padding: 0 .5em;\n            box-sizing: border-box;\n            transition: width .2s; }\n    .ToolsUI > .container .DialogMask {\n      z-index: 100;\n      content: \"test\";\n      display: block;\n      position: fixed;\n      left: 0;\n      top: 0;\n      height: 100vh;\n      width: 100vw;\n      background-color: rgba(0, 0, 0, 0.1); }\n\n.Dialog.Progress .meter {\n  height: 20px;\n  /* Can be anything */\n  position: relative;\n  margin: 60px 0 20px 0;\n  /* Just for demo spacing */\n  background: #555;\n  -moz-border-radius: 25px;\n  -webkit-border-radius: 25px;\n  border-radius: 25px;\n  padding: 10px;\n  -webkit-box-shadow: inset 0 -1px 1px rgba(255, 255, 255, 0.3);\n  -moz-box-shadow: inset 0 -1px 1px rgba(255, 255, 255, 0.3);\n  box-shadow: inset 0 -1px 1px rgba(255, 255, 255, 0.3); }\n\n.Dialog.Progress .meter > span {\n  display: block;\n  height: 100%;\n  background-color: #2bc253;\n  background-image: -webkit-gradient(linear, left bottom, left top, color-stop(0, #2bc253), color-stop(1, #54f054));\n  background-image: -moz-linear-gradient(center bottom, #2bc253 37%, #54f054 69%);\n  -webkit-box-shadow: inset 0 2px 9px rgba(255, 255, 255, 0.3), inset 0 -2px 6px rgba(0, 0, 0, 0.4);\n  -moz-box-shadow: inset 0 2px 9px rgba(255, 255, 255, 0.3), inset 0 -2px 6px rgba(0, 0, 0, 0.4);\n  box-shadow: inset 0 2px 9px rgba(255, 255, 255, 0.3), inset 0 -2px 6px rgba(0, 0, 0, 0.4);\n  position: relative;\n  overflow: hidden; }\n\n.Dialog.Progress .meter > span:after, .Dialog.Progress .animate > span > span {\n  content: \"\";\n  position: absolute;\n  top: 0;\n  left: 0;\n  bottom: 0;\n  right: 0;\n  background-image: -webkit-gradient(linear, 0 0, 100% 100%, color-stop(0.25, rgba(255, 255, 255, 0.2)), color-stop(0.25, transparent), color-stop(0.5, transparent), color-stop(0.5, rgba(255, 255, 255, 0.2)), color-stop(0.75, rgba(255, 255, 255, 0.2)), color-stop(0.75, transparent), to(transparent));\n  background-image: -moz-linear-gradient(-45deg, rgba(255, 255, 255, 0.2) 25%, transparent 25%, transparent 50%, rgba(255, 255, 255, 0.2) 50%, rgba(255, 255, 255, 0.2) 75%, transparent 75%, transparent);\n  z-index: 1;\n  -webkit-background-size: 50px 50px;\n  -moz-background-size: 50px 50px;\n  background-size: 50px 50px;\n  -webkit-animation: move 2s linear infinite;\n  -moz-animation: move 2s linear infinite;\n  overflow: hidden; }\n\n.Dialog.Progress .animate > span:after {\n  display: none; }\n\n@-webkit-keyframes move {\n  0% {\n    background-position: 0 0; }\n  100% {\n    background-position: 50px 50px; } }\n\n@-moz-keyframes move {\n  0% {\n    background-position: 0 0; }\n  100% {\n    background-position: 50px 50px; } }\n\n.Dialog.Progress .orange > span {\n  background-color: #f1a165;\n  background-image: -moz-linear-gradient(top, #f1a165, #f36d0a);\n  background-image: -webkit-gradient(linear, left top, left bottom, color-stop(0, #f1a165), color-stop(1, #f36d0a));\n  background-image: -webkit-linear-gradient(#f1a165, #f36d0a); }\n\n.Dialog.Progress .red > span {\n  background-color: #f0a3a3;\n  background-image: -moz-linear-gradient(top, #f0a3a3, #f42323);\n  background-image: -webkit-gradient(linear, left top, left bottom, color-stop(0, #f0a3a3), color-stop(1, #f42323));\n  background-image: -webkit-linear-gradient(#f0a3a3, #f42323); }\n\n.Dialog.Progress .nostripes > span > span, .Dialog.Progress .nostripes > span:after {\n  -webkit-animation: none;\n  -moz-animation: none;\n  background-image: none; }\n");

var defaultManager = {
    history: new HashHistory,
    getDirection: function (oldPath, newPath) {
        function parts(str) {
            return str.split('/').length;
        }
        function last(str) {
            return str.split('/').pop();
        }
        var reverse = (parts(oldPath) > parts(newPath))
            || (last(oldPath) > last(newPath));
        return {
            reverse: reverse
        };
    },
    redirects: {},
    skipAnimation: []
};
var Router = /** @class */ (function (_super) {
    __extends(Router, _super);
    function Router() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            path: ''
        };
        _this.manager = Object.assign({}, defaultManager, _this.props.manager);
        _this.onHistoryChange = function (path) {
            _this.setState({
                path: window.location.hash.replace('#', '')
            });
        };
        return _this;
    }
    //manager.history.redirects = manager.redirects
    Router.prototype.render = function () {
        var manager = this.manager;
        manager.history.redirects = manager.redirects;
        return createElement(ManagerProvier, { value: manager },
            createElement(PathProvier, { value: this.state.path }, this.props.children));
    };
    Object.defineProperty(Router.prototype, "history", {
        get: function () {
            return this.manager.history;
        },
        enumerable: true,
        configurable: true
    });
    Router.prototype.componentDidMount = function () {
        var history = this.history;
        history.addHandler(this.onHistoryChange).fire();
    };
    Router.prototype.componentWillUnmount = function () {
        this.manager.history.removeHandler(this.onHistoryChange);
    };
    return Router;
}(PureComponent));

var Transition = /** @class */ (function (_super) {
    __extends(Transition, _super);
    function Transition() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            components: [],
            props: null
        };
        _this.timers = [];
        return _this;
    }
    Transition.getDerivedStateFromProps = function (props, state) {
        if (props == state.props)
            return state;
        //compare prop to state comp list, new->enter, missing->leave
        var oldComps = state.components.map(function (info) { return info.comp; }), newComps = props.component ? [props.component] : Children.toArray(props['children']);
        var skip = (oldComps.length == 0) && (!props.transFirst), sampeComp = (oldComps.length == 1 && newComps.length == 1 && oldComps[0] == newComps[0]);
        var newCompInfos = newComps.map(function (newComp) {
            var existing = oldComps.some(function (co) { return co == newComp; });
            return {
                comp: newComp,
                action: existing || skip || sampeComp ? '' : 'WillEnter'
            };
        });
        var toLeave = oldComps.filter(function (c) { return newComps.indexOf(c) == -1; }).map(function (c) { return ({
            comp: c,
            action: 'WillLeave'
        }); });
        return {
            components: newCompInfos.concat(toLeave),
            props: props
        };
    };
    Transition.prototype.render = function () {
        var _this = this;
        var components = this.state.components, _a = this.props, getClassName = _a.getClassName, injectClass = _a.injectClass;
        return createElement(Fragment, null, components.map(function (c, i) {
            var className = getClassName(c.action);
            return (injectClass) ? (cloneElement(c.comp, __assign({}, c.comp.props, { className: className, key: i }))) : createElement("div", { key: i, style: {
                    transitionDuration: (_this.props.transitionDuration) + 'ms'
                }, className: getClassName(c.action) }, c.comp);
        }));
    };
    Transition.prototype.startAnimation = function () {
        var components = this.state.components, willEnters = components.filter(function (c) { return c.action == 'WillEnter'; }), willLeaves = components.filter(function (c) { return c.action == 'WillLeave'; });
        if (willEnters.length + willLeaves.length) {
            willEnters.forEach(function (c) { return c.action = 'Enter'; });
            willLeaves.forEach(function (c) { return c.action = 'Leave'; });
            this.setState({ components: components.slice() });
        }
    };
    Transition.prototype.fnishAnimation = function () {
        var components = this.state.components, enters = components.filter(function (c) { return c.action == 'Enter'; }), leaves = components.filter(function (c) { return c.action == 'Leave'; });
        if (enters.length + leaves.length) {
            var newComp = components.filter(function (c) { return leaves.indexOf(c) == -1; });
            newComp.forEach(function (c) { return c.action = ''; });
            this.setState({ components: newComp });
        }
    };
    Transition.prototype.clearTimer = function () {
        var timers = this.timers;
        if (timers.length) {
            timers.forEach(function (t) { return clearTimeout(t); });
            timers.length = 0;
        }
        return timers;
    };
    Transition.prototype.componentDidUpdate = function () {
        this.checkAnimation();
    };
    Transition.prototype.componentDidMount = function () {
        this.checkAnimation();
    };
    Transition.prototype.checkAnimation = function () {
        var _this = this;
        var components = this.state.components;
        if (components.some(function (c) { return c.action.startsWith('Will'); })) {
            var timers = this.clearTimer();
            timers.push(setTimeout(function () {
                _this.startAnimation();
            }, 10));
            timers.push(setTimeout(function () {
                _this.fnishAnimation();
            }, this.props.transitionDuration));
        }
    };
    Transition.prototype.componentWillUnmount = function () {
        this.clearTimer();
    };
    Transition.defaultProps = {
        transitionDuration: 300,
        getClassName: function (action) { return action; },
        transFirst: false,
        injectClass: false
    };
    return Transition;
}(PureComponent));

var Carousel = /** @class */ (function (_super) {
    __extends(Carousel, _super);
    function Carousel() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.root = createRef();
        _this._oldPath = '';
        _this.size = { width: 0, height: 0 };
        return _this;
    }
    Carousel.prototype.render = function () {
        var _a = this.props, path = _a.path, manager = _a.manager;
        if (!path)
            return null;
        var _b = this.props, getComponent = _b.children, transitionDuration = _b.transitionDuration, comp = getComponent(path), reverse = manager.getDirection(this._oldPath, path).reverse, getClassName = function (action) {
            var className = {
                WillEnter: 'enter',
                Leave: 'leave',
                Enter: 'stay',
                WillLeave: 'stay'
            }[action] || '';
            if (reverse) {
                className = {
                    'enter': 'leave', 'leave': 'enter'
                }[className] || className;
            }
            return className;
        };
        var body = (manager.skipAnimation.indexOf(path) != -1) ? createElement("div", null, comp) :
            createElement(Transition, { transitionDuration: transitionDuration, getClassName: getClassName, component: comp });
        this._oldPath = path;
        return (createElement("div", { className: classnames('srCarousel', this.props.className), ref: this.root }, body));
    };
    Carousel.prototype.readSize = function () {
        var rootDiv = this.root.current;
        if (rootDiv) {
            var _a = rootDiv.getBoundingClientRect(), width = _a.width, height = _a.height;
            this.size.width = width;
            this.size.height = height;
        }
    };
    Carousel.prototype.componentDidUpdate = function () {
        this.readSize();
    };
    Carousel.prototype.componentDidMount = function () {
        this.readSize();
    };
    Carousel = __decorate([
        withManager,
        withPath
    ], Carousel);
    return Carousel;
}(PureComponent));

var Folder = /** @class */ (function (_super) {
    __extends(Folder, _super);
    function Folder() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            show: false,
            action: '',
            props: null,
            firstRender: true,
            mounted: false
        };
        _this.timers = [];
        return _this;
    }
    Folder.getDerivedStateFromProps = function (props, state) {
        //no need to handle them 
        if (!state.mounted || props == state.props)
            return state;
        var test = props.test, path = props.path, show = match(path, test);
        if (show !== state.show) {
            var action = show ? 'WillEnter' : 'WillLeave';
            if (state.firstRender)
                action = '';
            return {
                show: true, action: action, props: props,
                firstRender: false
            };
        }
        return __assign({}, state, { firstRender: false });
    };
    Folder.prototype.render = function () {
        var _a = this.props, path = _a.path, manager = _a.manager, transitionDuration = _a.transitionDuration;
        if (!path)
            return null;
        var _b = this.state, action = _b.action, show = _b.show;
        var content = this.props.children;
        var clsName = {
            WillEnter: 'leave',
            Leave: 'leave',
            Enter: 'stay',
            WillLeave: 'stay'
        }[action] || '';
        return (createElement("div", { className: classnames('srFolder', this.props.className, clsName, { hidden: !show }), style: {
                transitionDuration: (this.props.transitionDuration) + 'ms'
            } }, content));
    };
    Folder.prototype.clearTimer = function () {
        var timers = this.timers;
        if (timers.length) {
            timers.forEach(function (t) { return clearTimeout(t); });
            timers.length = 0;
        }
        return timers;
    };
    Folder.prototype.componentDidUpdate = function () {
        var _this = this;
        var action = this.state.action;
        if (action.startsWith('Will')) {
            var timers = this.clearTimer();
            timers.push(setTimeout(function () {
                _this.setState({ action: action.replace('Will', '') });
            }, 10));
            timers.push(setTimeout(function () {
                _this.setState({
                    action: '',
                    show: !action.endsWith('Leave')
                });
            }, this.props.transitionDuration));
        }
    };
    Folder.prototype.componentDidMount = function () {
        this.state.mounted = true;
    };
    Folder.prototype.componentWillUnmount = function () {
        this.state.mounted = false;
    };
    Folder.defaultProps = {
        transitionDuration: 300
    };
    Folder = __decorate([
        withManager,
        withPath
    ], Folder);
    return Folder;
}(PureComponent));

var Redirect = /** @class */ (function (_super) {
    __extends(Redirect, _super);
    function Redirect() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Redirect.prototype.render = function () {
        return null;
    };
    Redirect.prototype.componentDidUpdate = function () {
        this.execute();
    };
    Redirect.prototype.execute = function () {
        console.log(this.props.to);
    };
    return Redirect;
}(Component));

var BackButton = /** @class */ (function (_super) {
    __extends(BackButton, _super);
    function BackButton() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.click = function () {
            _this.props.manager.history.goBack();
        };
        return _this;
    }
    BackButton.prototype.render = function () {
        return createElement("a", { onClick: this.click, className: 'BackButton' },
            " ",
            this.props.children,
            "  ");
    };
    BackButton = __decorate([
        withManager
    ], BackButton);
    return BackButton;
}(PureComponent));



var index = /*#__PURE__*/Object.freeze({
    PathProvier: PathProvier,
    withPath: withPath,
    ManagerProvier: ManagerProvier,
    withManager: withManager,
    match: match,
    Route: Route,
    Link: Link,
    Router: Router,
    Carousel: Carousel,
    Folder: Folder,
    Redirect: Redirect,
    BackButton: BackButton
});

/**
 * @this {Promise}
 */
function finallyConstructor(callback) {
  var constructor = this.constructor;
  return this.then(
    function(value) {
      return constructor.resolve(callback()).then(function() {
        return value;
      });
    },
    function(reason) {
      return constructor.resolve(callback()).then(function() {
        return constructor.reject(reason);
      });
    }
  );
}

// Store setTimeout reference so promise-polyfill will be unaffected by
// other code modifying setTimeout (like sinon.useFakeTimers())
var setTimeoutFunc = setTimeout;

function noop() {}

// Polyfill for Function.prototype.bind
function bind(fn, thisArg) {
  return function() {
    fn.apply(thisArg, arguments);
  };
}

/**
 * @constructor
 * @param {Function} fn
 */
function Promise$1(fn) {
  if (!(this instanceof Promise$1))
    throw new TypeError('Promises must be constructed via new');
  if (typeof fn !== 'function') throw new TypeError('not a function');
  /** @type {!number} */
  this._state = 0;
  /** @type {!boolean} */
  this._handled = false;
  /** @type {Promise|undefined} */
  this._value = undefined;
  /** @type {!Array<!Function>} */
  this._deferreds = [];

  doResolve(fn, this);
}

function handle(self, deferred) {
  while (self._state === 3) {
    self = self._value;
  }
  if (self._state === 0) {
    self._deferreds.push(deferred);
    return;
  }
  self._handled = true;
  Promise$1._immediateFn(function() {
    var cb = self._state === 1 ? deferred.onFulfilled : deferred.onRejected;
    if (cb === null) {
      (self._state === 1 ? resolve : reject)(deferred.promise, self._value);
      return;
    }
    var ret;
    try {
      ret = cb(self._value);
    } catch (e) {
      reject(deferred.promise, e);
      return;
    }
    resolve(deferred.promise, ret);
  });
}

function resolve(self, newValue) {
  try {
    // Promise Resolution Procedure: https://github.com/promises-aplus/promises-spec#the-promise-resolution-procedure
    if (newValue === self)
      throw new TypeError('A promise cannot be resolved with itself.');
    if (
      newValue &&
      (typeof newValue === 'object' || typeof newValue === 'function')
    ) {
      var then = newValue.then;
      if (newValue instanceof Promise$1) {
        self._state = 3;
        self._value = newValue;
        finale(self);
        return;
      } else if (typeof then === 'function') {
        doResolve(bind(then, newValue), self);
        return;
      }
    }
    self._state = 1;
    self._value = newValue;
    finale(self);
  } catch (e) {
    reject(self, e);
  }
}

function reject(self, newValue) {
  self._state = 2;
  self._value = newValue;
  finale(self);
}

function finale(self) {
  if (self._state === 2 && self._deferreds.length === 0) {
    Promise$1._immediateFn(function() {
      if (!self._handled) {
        Promise$1._unhandledRejectionFn(self._value);
      }
    });
  }

  for (var i = 0, len = self._deferreds.length; i < len; i++) {
    handle(self, self._deferreds[i]);
  }
  self._deferreds = null;
}

/**
 * @constructor
 */
function Handler(onFulfilled, onRejected, promise) {
  this.onFulfilled = typeof onFulfilled === 'function' ? onFulfilled : null;
  this.onRejected = typeof onRejected === 'function' ? onRejected : null;
  this.promise = promise;
}

/**
 * Take a potentially misbehaving resolver function and make sure
 * onFulfilled and onRejected are only called once.
 *
 * Makes no guarantees about asynchrony.
 */
function doResolve(fn, self) {
  var done = false;
  try {
    fn(
      function(value) {
        if (done) return;
        done = true;
        resolve(self, value);
      },
      function(reason) {
        if (done) return;
        done = true;
        reject(self, reason);
      }
    );
  } catch (ex) {
    if (done) return;
    done = true;
    reject(self, ex);
  }
}

Promise$1.prototype['catch'] = function(onRejected) {
  return this.then(null, onRejected);
};

Promise$1.prototype.then = function(onFulfilled, onRejected) {
  // @ts-ignore
  var prom = new this.constructor(noop);

  handle(this, new Handler(onFulfilled, onRejected, prom));
  return prom;
};

Promise$1.prototype['finally'] = finallyConstructor;

Promise$1.all = function(arr) {
  return new Promise$1(function(resolve, reject) {
    if (!arr || typeof arr.length === 'undefined')
      throw new TypeError('Promise.all accepts an array');
    var args = Array.prototype.slice.call(arr);
    if (args.length === 0) return resolve([]);
    var remaining = args.length;

    function res(i, val) {
      try {
        if (val && (typeof val === 'object' || typeof val === 'function')) {
          var then = val.then;
          if (typeof then === 'function') {
            then.call(
              val,
              function(val) {
                res(i, val);
              },
              reject
            );
            return;
          }
        }
        args[i] = val;
        if (--remaining === 0) {
          resolve(args);
        }
      } catch (ex) {
        reject(ex);
      }
    }

    for (var i = 0; i < args.length; i++) {
      res(i, args[i]);
    }
  });
};

Promise$1.resolve = function(value) {
  if (value && typeof value === 'object' && value.constructor === Promise$1) {
    return value;
  }

  return new Promise$1(function(resolve) {
    resolve(value);
  });
};

Promise$1.reject = function(value) {
  return new Promise$1(function(resolve, reject) {
    reject(value);
  });
};

Promise$1.race = function(values) {
  return new Promise$1(function(resolve, reject) {
    for (var i = 0, len = values.length; i < len; i++) {
      values[i].then(resolve, reject);
    }
  });
};

// Use polyfill for setImmediate for performance gains
Promise$1._immediateFn =
  (typeof setImmediate === 'function' &&
    function(fn) {
      setImmediate(fn);
    }) ||
  function(fn) {
    setTimeoutFunc(fn, 0);
  };

Promise$1._unhandledRejectionFn = function _unhandledRejectionFn(err) {
  if (typeof console !== 'undefined' && console) {
    console.warn('Possible Unhandled Promise Rejection:', err); // eslint-disable-line no-console
  }
};

/** @suppress {undefinedVars} */
var globalNS = (function() {
  // the only reliable means to get the global object is
  // `Function('return this')()`
  // However, this causes CSP violations in Chrome apps.
  if (typeof self !== 'undefined') {
    return self;
  }
  if (typeof window !== 'undefined') {
    return window;
  }
  if (typeof global !== 'undefined') {
    return global;
  }
  throw new Error('unable to locate global object');
})();

if (!('Promise' in globalNS)) {
  globalNS['Promise'] = Promise$1;
} else if (!globalNS.Promise.prototype['finally']) {
  globalNS.Promise.prototype['finally'] = finallyConstructor;
}

if (!String.prototype.startsWith) {
    String.prototype.startsWith = function (searchString, position) {
        position = position || 0;
        return this.indexOf(searchString, position) === position;
    };
}
if (!String.prototype.endsWith) {
    String.prototype.endsWith = function (search, this_len) {
        if (this_len === undefined || this_len > this.length) {
            this_len = this.length;
        }
        return this.substring(this_len - search.length, this_len) === search;
    };
}
if (typeof Object.assign != 'function') {
    // Must be writable: true, enumerable: false, configurable: true
    Object.defineProperty(Object, "assign", {
        value: function assign(target, varArgs) {
            if (target == null) { // TypeError if undefined or null
                throw new TypeError('Cannot convert undefined or null to object');
            }
            var to = Object(target);
            for (var index = 1; index < arguments.length; index++) {
                var nextSource = arguments[index];
                if (nextSource != null) { // Skip over if undefined or null
                    for (var nextKey in nextSource) {
                        // Avoid bugs when hasOwnProperty is shadowed
                        if (Object.prototype.hasOwnProperty.call(nextSource, nextKey)) {
                            to[nextKey] = nextSource[nextKey];
                        }
                    }
                }
            }
            return to;
        },
        writable: true,
        configurable: true
    });
}

//const effect = createTag('Effect') as Tag
/** effects handles side effects/async tasks, the method needs to be async  */
function effect(target, key, desc) {
    target[key]['isEffect'] = true;
}
function singleEffect(target, key, desc) {
    target[key]['isEffect'] = true;
    target[key]['singleEffect'] = true;
}
/** computed fields can be used in 'connect', it output values based on state  */
function computed(target, key, desc) {
    target[key]['isComputed'] = true;
}
/** tag a method a middleware, can only be used on method of a Plugin class  */
function middleware(target, key, desc) {
    target[key]['isMiddleware'] = true;
}
/**
 * Model class provides helper methods like getSibling.
 * It's not mandatory for a model to extend this class, unless it needs those methods
 */
var Model = /** @class */ (function () {
    function Model() {
    }
    /**
     * fetch sibling model for reading its state or calling its reducer/effect
     * @param modelId
     */
    Model.prototype.importModel = function (Class) {
        return null;
    };
    Model.prototype.events = function () {
        return null;
    };
    /** trigged when model is installed  */
    Model.prototype.onModelInstalled = function (storeSore, dispatch, modelId) { };
    return Model;
}());
/**
 * Implement Plugin to provide common functions like logging, displaying loading bar
 * Plugin class doesn't provide any extra function than Model class, at the moment
 */
var Plugin = /** @class */ (function (_super) {
    __extends(Plugin, _super);
    function Plugin() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._isPlugin_ = true;
        return _this;
    }
    return Plugin;
}(Model));
/**
 * the UI Events handls small user interaction, like alert or prompt.
 * service store contains a single events.
 */
var UIEvents = /** @class */ (function () {
    function UIEvents() {
        this.pool = {};
        this.observers = [];
    }
    UIEvents.prototype.run = function (onStart, onFinish) {
        var _this = this;
        var pool = this.pool, id = this.createUniqId();
        return new Promise(function (resolve) {
            onStart(id);
            pool[id] = function (ret) {
                if (onFinish)
                    onFinish(ret);
                resolve(ret);
            };
            _this.notify();
        });
    };
    UIEvents.prototype.createUniqId = function () {
        return (Date.now().toString(36) +
            Math.random()
                .toString(36)
                .substr(2, 5)).toUpperCase();
    };
    UIEvents.prototype.solve = function (pid, ret) {
        var solve = this.pool[pid];
        solve(ret);
        delete this.pool[pid];
        this.notify();
    };
    Object.defineProperty(UIEvents.prototype, "count", {
        get: function () {
            return Object.keys(this.pool).length;
        },
        enumerable: true,
        configurable: true
    });
    UIEvents.prototype.notify = function () {
        var _this = this;
        this.observers.forEach(function (ob) { return ob(_this); });
    };
    UIEvents.prototype.addObserver = function (ob) {
        this.observers.push(ob);
    };
    return UIEvents;
}());



var LoadingUI = /** @class */ (function (_super) {
    __extends(LoadingUI, _super);
    function LoadingUI() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    LoadingUI.prototype.render = function () {
        var isLoading = this.props.isLoading;
        return createElement(Fragment, null, isLoading ? createElement("div", { className: 'loader-wrapper' },
            createElement("div", { className: 'loader' })) : null);
    };
    return LoadingUI;
}(PureComponent));
function createUI(store) {
    var connect$$1 = store.connect, modelId = store.getModelIdByClass(Loading);
    var Cls = connect$$1(function (s) {
        var model = s[modelId], isLoading = (model.uiSessionCount == 0) && (model.count() > 0);
        return { isLoading: isLoading };
    })(LoadingUI);
    return Cls;
}

/* built in models */
/**
 * for showing loading status
 */
var Loading = /** @class */ (function (_super) {
    __extends(Loading, _super);
    function Loading() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.current = {};
        _this.uiSessionCount = 0;
        return _this;
    }
    Loading.prototype.count = function () {
        var current = this.current;
        return Object.keys(current).reduce(function (count, key) { return count + current[key]; }, 0);
    };
    Loading.prototype.addAction = function (actionType) {
        this.current[actionType] = (this.current[actionType] || 0) + 1;
    };
    Loading.prototype.removeAction = function (actionType) {
        this.current[actionType] = this.current[actionType] - 1;
    };
    Loading.prototype.clearAll = function () {
        this.current = {};
    };
    Loading.prototype.onDispatch = function (ctx, info) {
        var isEffect = info.isEffect, isEffectFinish = info.isEffectFinish, type = info.type, serviceStore = info.serviceStore;
        if (serviceStore.effects.length == 0 && this.count() > 0) {
            //force clear all
            this.clearAll();
            return;
        }
        if (isEffect) {
            if (isEffectFinish) {
                this.removeAction(type);
            }
            else {
                this.addAction(type);
            }
        }
    };
    Loading.prototype.setUiSessionCount = function (count) {
        this.uiSessionCount = count;
    };
    Loading.prototype.onModelInstalled = function (store, dispatch, modelId) {
        var events = store.events;
        events.addObserver(function (ob) { return dispatch.setUiSessionCount(ob.count); });
        store.pluginUIs.push(createUI(store));
    };
    __decorate([
        computed,
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], Loading.prototype, "count", null);
    __decorate([
        middleware,
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object, Object]),
        __metadata("design:returntype", void 0)
    ], Loading.prototype, "onDispatch", null);
    return Loading;
}(Plugin));

var Logging = /** @class */ (function (_super) {
    __extends(Logging, _super);
    function Logging(cfg) {
        var _this = _super.call(this) || this;
        _this._privateFields_ = ['effectPool', 'log', 'filter'];
        _this.effectPool = {};
        Object.assign(_this, cfg);
        return _this;
    }
    Logging.prototype.log = function (type, payload, state, queue) {
        var modelId = type.split('/')[0];
        if (state[modelId])
            state = state[modelId];
        console.groupCollapsed(type);
        console.log('payload:', payload);
        if (!queue) {
            console.log('state:', state);
        }
        else if (queue.length) {
            console.groupCollapsed('reducers:' + queue.map(function (q) { return q.type; }).join(','));
            queue.forEach(function (q) {
                console.group(q.type + ' start at ' + q.time);
                console.log('payload:', q.payload);
                console.log('state:', q.state);
                console.groupEnd();
            });
            console.groupEnd();
            console.log('state:', state);
        }
        console.groupEnd();
    };
    Logging.prototype.filter = function (ctx, mCtx) {
        return true;
    };
    Logging.prototype.onDispatch = function (ctx, info) {
        var _a = info.model, log = _a.log, filter = _a.filter, effectPool = _a.effectPool, type = info.type, isPluginAction = info.isPluginAction, isEffect = info.isEffect, isEffectFinish = info.isEffectFinish, effectRootId = info.effectRootId, action = ctx.action, next = ctx.next, store = ctx.store, modelId = type.split('/')[0], result = next(action); //to finish effect first 
        if (!isPluginAction && filter(ctx, info)) {
            var state = store.getState()[modelId], _b = action, payload = _b.payload, effectId = _b.effectId;
            if (effectId) {
                var isRoot = (effectId == effectRootId);
                //console.log(type + '=' + effectId + ',' + effectRootId)
                if (!effectPool[effectId]) {
                    effectPool[effectId] = { start: Date.now(), queue: [], payload: payload };
                }
                var _c = effectPool[effectId], queue = _c.queue, start = _c.start, time = Date.now() - start + 'ms';
                if (isEffectFinish && isRoot) { //take out and log when effect finishes 
                    //console.log('-----------aaa')
                    if (type == queue[0].type) {
                        var first = queue.shift();
                        log(type + " (total:" + time + ")", first.payload, state, queue);
                        delete effectPool[effectId];
                    }
                }
                else {
                    var record = { type: type, time: time, payload: payload, state: state, isEffect: isEffect };
                    if (!queue.some(function (q) { return q.isEffect; })) {
                        queue.unshift(record);
                    }
                    else {
                        queue.push(record);
                    }
                }
            }
            else {
                log(type, payload, state);
            }
        }
        return result === undefined ? null : result;
    };
    __decorate([
        middleware,
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object, Object]),
        __metadata("design:returntype", void 0)
    ], Logging.prototype, "onDispatch", null);
    return Logging;
}(Plugin));



function iterate(obj, keys, func) {
    var skipFields = (obj['_privateFields_'] || []).concat(['onModelInstalled']), filter = function (k) { return !(k.startsWith('_') || includes(skipFields, k) || k == 'constructor'); };
    keys.filter(filter).forEach(function (key) {
        try {
            func(obj[key], key);
        }
        catch (e) {
            console.error(key);
        }
    });
}
/**iterate object*/
function each(obj, func) {
    iterate(obj, Object.keys(obj), func);
}
/**iterate model methods*/
function eachMethod(obj, func) {
    var keys = Object.getOwnPropertyNames(Object.getPrototypeOf(obj));
    iterate(obj, keys, func);
}
function includes(array, item) {
    return array.indexOf(item) != -1;
}
var Effect = /** @class */ (function () {
    function Effect(id, actionType) {
        this.id = id;
        this.actionType = actionType;
        this.children = [];
        this.startTime = 0;
        this.finishTime = 0;
    }
    Effect.prototype.start = function () {
        this.startTime = Date.now();
        this.onStart();
    };
    Effect.prototype.finish = function () {
        this.finishTime = Date.now();
        this.onFinish();
    };
    Effect.prototype.onStart = function () { };
    Effect.prototype.onFinish = function () { };
    Effect.prototype.cancel = function () { };
    return Effect;
}());
var _a$1 = createContext(null), UIEventsProvider = _a$1.Provider, UIEventsConsumer = _a$1.Consumer;
/**
 * convert class to redux state & action
 * @param cls
 * @param modelId
 */
var ServiceStore = /** @class */ (function () {
    function ServiceStore(models, middleware$$1, reducer) {
        if (middleware$$1 === void 0) { middleware$$1 = []; }
        var _this = this;
        this.models = models;
        this.dispatcher = {};
        this.computedFields = {};
        this.events = new UIEvents();
        this.effects = [];
        this.modelHelper = {
            importModel: function (Class) {
                var s = _this, modelId = s.getModelIdByClass(Class), dispatch = s.dispatch[modelId], state = s.store.getState()[modelId], computed$$1 = s.computedFields[modelId];
                if (!state) {
                    var modeIds = Object.keys(s.models).join(','), msg = modelId + " is not a valid model ID. Currently installed:" + modeIds + " }";
                    console.error(msg);
                    return null;
                }
                return __assign({}, state, computed$$1, dispatch);
            },
            events: function () {
                return _this.events;
            }
        };
        this.dispatchPool = {};
        this._lastState = null;
        this._lastMergedState = null;
        this.pluginUIs = [];
        this.getService = function (name) {
            return _this.dispatch[name];
        };
        var dispatcher = this.dispatcher, reducers = {}, effectTypes = [], effectFunctions = {}, modelMiddleware = [], pluginIds = [];
        each(models, function (model, modelId) {
            /* for each model, create state, reducers*/
            //create state from fields
            var model_state = {};
            each(model, function (val, key) { return (model_state[key] = val); });
            //create reducer,middleware,effect,calcluated field from methods
            var model_dispatch = (dispatcher[modelId] = {}), //dispatch wrapper, so we can dispatch with method calling
            model_computedFields = (_this.computedFields[modelId] = {}), //calcuated fields
            model_reducers = []; //reducers
            var isPlugin = model instanceof Plugin;
            eachMethod(model, function (method, methodName) {
                if (method.isComputed) {
                    //calc fields
                    model_computedFields[methodName] = method;
                }
                else if (method.isMiddleware) {
                    // middleware. every middleware is called on every dispatch
                    modelMiddleware.push(function (store) { return function (next) { return function (action) {
                        var type = action.type, isEffect = includes(effectTypes, action.type), isEffectFinish = action.isEffectFinish, isPluginAction = includes(pluginIds, type.split('/')[0]), serviceStore = _this, effectId = action.effectId, effectRootId = _this.getEffectRootId(effectId);
                        var ret = method.call(__assign({}, store.getState()[modelId], model_computedFields, model_dispatch), { store: store, next: next, action: action }, {
                            isEffect: isEffect, isEffectFinish: isEffectFinish, isPluginAction: isPluginAction,
                            model: model, type: type, serviceStore: serviceStore, effectId: effectId, effectRootId: effectRootId
                        });
                        return (ret === undefined) ? next(action) : ret;
                    }; }; });
                }
                else {
                    //effect or reducer
                    var actionType_1 = modelId + "/" + methodName;
                    if (method.isEffect) {
                        //effect
                        effectTypes.push(actionType_1);
                        effectFunctions[actionType_1] = { modelId: modelId, methodName: methodName, method: method };
                    }
                    else {
                        //reducer
                        var reducer_1 = function (state, action) {
                            var match = action.type == actionType_1;
                            return match ? produce(state, function (draftState) {
                                method.call(draftState, action.payload);
                            }) : state;
                        };
                        model_reducers.push(reducer_1);
                    }
                    //a dispatch method for firing action (effect or reducer)
                    model_dispatch[methodName] = function (payload) {
                        return store.dispatch({ type: actionType_1, payload: payload });
                    };
                    if (method.singleEffect) {
                        var effectMethod_1 = model_dispatch[methodName], singletonM = function (payload) {
                            var _a = method.singleEffect, runAt = _a.runAt, debounce = _a.debounce;
                            var effect$$1 = _this.getEffectByActionType(actionType_1);
                            if (effect$$1)
                                effect$$1.cancel();
                            return effectMethod_1(payload);
                        };
                        model_dispatch[methodName] = singletonM;
                    }
                }
            });
            //combine reducers in one model
            reducers[modelId] = function (state, action) {
                return model_reducers.reduce(function (s, reducer) { return reducer(s, action); }, state == undefined ? model_state : state //todo maybe should use init state in createstore
                );
            };
            if (isPlugin) {
                pluginIds.push(modelId);
            }
            if (model['onModelInstalled']) {
                model['onModelInstalled'](_this, model_dispatch, modelId);
            }
        });
        /**
         * the middleware to handle effects
         * @param store
         */
        var effectHandler = function (store) { return function (next) { return function (action) {
            var _a = action, type = _a.type, isEffectFinish = _a.isEffectFinish;
            //to achieve effect cancelling, for example, a effect does ajax then calls a reducer.
            //you can cancel it when it's running , the reducer will be blocked
            if (action.effectId) {
                if (!_this.hasEffect(action.effectId)) {
                    throw action.type + " has been cancelled";
                }
            }
            //pass if it is a reducer
            if (!includes(effectTypes, type))
                return next(action);
            //this is a 'finishing' action, effect just finished
            if (isEffectFinish) {
                //console.log('effectHandler closing...', action.type) 
                var effect_1 = _this.getEffectById(action.effectId);
                if (effect_1) {
                    //console.log(effect)
                    effect_1.finish();
                }
                else {
                    console.log('cannot find when close', action);
                }
                //console.log(this.effects)
                return action.payload;
            }
            //handle effect
            var _b = effectFunctions[type], modelId = _b.modelId, method = _b.method;
            //start an effect
            var effect$$1 = _this.createEffect(type, action.effectId), effectId = action.effectId = effect$$1.id;
            var effectDispatch = {};
            Object.keys(_this.dispatcher[modelId]).forEach(function (methodName) {
                effectDispatch[methodName] = function (payload) {
                    return store.dispatch({
                        type: modelId + "/" + methodName,
                        payload: payload, effectId: effectId
                    });
                };
            });
            var state = store.getState(), modelState = state[modelId], computed$$1 = _this.computedFields[modelId], helper = models[modelId] instanceof Model ? _this.modelHelper : null, mixedContext = __assign({}, modelState, computed$$1, effectDispatch, helper);
            effect$$1.start();
            var ret = method.call(mixedContext, action.payload, state);
            next(action);
            //use Promise.resolve incase effect returns non promise
            return Promise.resolve(ret).then(function (payload) {
                return store.dispatch({
                    type: type, payload: payload, effectId: effectId,
                    isEffectFinish: true
                });
            }).catch(function (reason) {
                console.log(reason);
            });
        }; }; };
        var combinedReducer = combineReducers(reducers);
        if (reducer) {
            //compose
            var _reducer_1 = combinedReducer;
            combinedReducer = function (state, action) {
                return reducer(_reducer_1(state, action), action);
            };
        }
        var composeEnhancers = window['__REDUX_DEVTOOLS_EXTENSION_COMPOSE__'] || compose;
        middleware$$1 = modelMiddleware.concat([effectHandler]).concat(middleware$$1);
        var store = this.store = createStore(combinedReducer, composeEnhancers(applyMiddleware.apply(void 0, middleware$$1)));
    }
    ServiceStore.prototype.getEffect = function (match) {
        function search(effects) {
            var find = null;
            effects.some(function (c) {
                if (match(c)) {
                    find = c;
                    return true;
                }
                else {
                    find = search(c.children);
                    return find != null;
                }
            });
            return find;
        }
        return search(this.effects);
    };
    ServiceStore.prototype.getEffectById = function (id) {
        return this.getEffect(function (effect$$1) { return effect$$1.id == id; });
    };
    ServiceStore.prototype.getEffectByActionType = function (actionType) {
        return this.getEffect(function (effect$$1) { return effect$$1.actionType == actionType; });
    };
    ServiceStore.prototype.removeEffect = function (id) {
        var effect$$1 = this.getEffectById(id);
        if (effect$$1) {
            if (effect$$1.parent) {
                effect$$1.parent.children = effect$$1.parent.children.filter(function (c) { return c != effect$$1; });
            }
            this.effects = this.effects.filter(function (e) { return e !== effect$$1; });
        }
    };
    ServiceStore.prototype.getEffectRoot = function (id) {
        var effect$$1 = this.getEffectById(id);
        while (effect$$1 && effect$$1.parent) {
            effect$$1 = effect$$1.parent;
        }
        return effect$$1;
    };
    ServiceStore.prototype.getEffectRootId = function (id) {
        var root = this.getEffectRoot(id);
        return root ? root.id : null;
    };
    ServiceStore.prototype.hasEffect = function (id) {
        return this.getEffectById(id) != null;
    };
    ServiceStore.prototype.createEffect = function (actionType, parentId) {
        var _this = this;
        var effectId = Date.now() + (Math.random() + '').substring(2), effect$$1 = new Effect(effectId, actionType);
        if (parentId) {
            var parent_1 = this.getEffectById(parentId);
            if (parent_1) {
                parent_1.children.push(effect$$1);
                effect$$1.parent = parent_1;
            }
        }
        else {
            this.effects.push(effect$$1);
        }
        effect$$1.onFinish = function () {
            _this.removeEffect(effect$$1.id);
        };
        effect$$1.cancel = function () {
            _this.store.dispatch({
                type: actionType, payload: null, effectId: effectId,
                isEffectFinish: true
            });
        };
        return effect$$1;
    };
    /**
     * return the targetting model of the action
     * @param actionType
     */
    ServiceStore.prototype.getModelByActionType = function (actionType) {
        var modelId = actionType.split('/')[0];
        return this.models[modelId];
    };
    ServiceStore.prototype.getModelIdByClass = function (actionType) {
        var modelId = null;
        each(this.models, function (val, key) {
            var match = val instanceof actionType;
            if (match)
                modelId = key;
        });
        return modelId;
    };
    Object.defineProperty(ServiceStore.prototype, "dispatch", {
        get: function () {
            return this.dispatcher;
        },
        enumerable: true,
        configurable: true
    });
    ServiceStore.prototype.getEffectDispatch = function (effectId) {
        var dispatchPool = this.dispatchPool;
        if (!dispatchPool[effectId]) {
            var effectDispatch_1 = (dispatchPool[effectId] = {}), _a = this, dispatcher = _a.dispatcher, store_1 = _a.store;
            each(dispatcher, function (modelDispatch, modelId) {
                var modelEffectDispatch = (effectDispatch_1[modelId] = {});
                each(modelDispatch, function (method, methodName) {
                    modelEffectDispatch[methodName] = function (payload) {
                        var type = modelId + "/" + methodName;
                        store_1.dispatch({ type: type, payload: payload, effectId: effectId });
                    };
                });
            });
        }
        return dispatchPool[effectId];
    };
    Object.defineProperty(ServiceStore.prototype, "state", {
        /**
         * root state, doesn't feel very useful?
         */
        get: function () {
            return this.store.getState();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ServiceStore.prototype, "connect", {
        /**
         * connect decorator to use with React.Component.
         * it maps state (or calcudated fields) to component props
         */
        get: function () {
            var _this = this;
            var connect$$1 = function (stateMap //decorator factory
            ) { return function (method) { return connect(function () { return stateMap(_this.getMergedState()); })(method); }; };
            return connect$$1;
        },
        enumerable: true,
        configurable: true
    });
    ServiceStore.prototype.getMergedState = function () {
        var _this = this;
        var state = this.state;
        if (state == this._lastState)
            return this._lastMergedState; //use cache
        var mergedState = {};
        Object.keys(state).forEach(function (modelId) {
            var modelState = state[modelId], computed$$1 = _this.computedFields[modelId], helper = _this.models[modelId] instanceof Model ? _this.modelHelper : null;
            mergedState[modelId] = __assign({}, modelState, computed$$1, helper);
        });
        this._lastState = state;
        this._lastMergedState = mergedState;
        return mergedState;
    };
    Object.defineProperty(ServiceStore.prototype, "Provider", {
        get: function () {
            var _this = this;
            var _a = this, store = _a.store, pluginUIs = _a.pluginUIs;
            return function (props) {
                var pluginEles = pluginUIs.map(function (ui, i) { return createElement(ui, { key: i }); }), propChildren = Children.toArray(props.children), wrapper = createElement(Fragment, {}, pluginEles.concat(propChildren));
                return createElement(UIEventsProvider, { value: _this.events }, createElement(Provider, { store: store }, wrapper));
            };
        },
        enumerable: true,
        configurable: true
    });
    return ServiceStore;
}());
function createStore$1(models, middlewares, reducer) {
    return new ServiceStore(models, middlewares, reducer);
}
function withUIEvents(Component$$1) {
    return function Wrapper(props) {
        return (createElement(UIEventsConsumer, null, function (events) { return createElement(Component$$1, __assign({}, props, { events: events })); }));
    };
}

var ToolsUI = /** @class */ (function (_super) {
    __extends(ToolsUI, _super);
    function ToolsUI() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ToolsUI.prototype.render = function () {
        var _a = this.props, dialogs = _a.dialogs, progress = _a.progress, dialogsEle = (dialogs && dialogs.length) ?
            dialogs.map(function (config, i) { return (createElement(Dialog, { config: config, key: 'dialog_' + config.id })); }) : null, progressEle = (progress && progress.percentage > 0) ?
            createElement(Progress, { config: progress, key: 'progress' }) : null;
        return createElement("div", { className: 'ToolsUI' },
            dialogsEle,
            progressEle);
    };
    return ToolsUI;
}(PureComponent));
var Dialog = /** @class */ (function (_super) {
    __extends(Dialog, _super);
    function Dialog() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.btnClick = function (idx) {
            var _a = _this.props, events = _a.events, config = _a.config;
            events.solve(config.id, idx);
        };
        return _this;
    }
    Dialog.prototype.render = function () {
        var _this = this;
        var _a = this.props, config = _a.config, className = _a.className, title = config.title, message = config.message;
        var buttons = config.buttons || ['OK'];
        return createElement("div", { className: 'container' },
            createElement("div", { className: classnames("Dialog", className) },
                (title) ? createElement("div", { className: 'header' }, title) : null,
                createElement("div", { className: 'content' }, message),
                createElement("div", { className: 'actions' }, buttons.map(function (b, i) { return createElement("button", { key: b, onClick: function () {
                        _this.btnClick(i);
                    } }, b); }))),
            createElement("div", { className: "DialogMask" }));
    };
    Dialog = __decorate([
        withUIEvents
    ], Dialog);
    return Dialog;
}(Component));
var Progress = /** @class */ (function (_super) {
    __extends(Progress, _super);
    function Progress() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Progress.prototype.render = function () {
        var _a = this.props, events = _a.events, config = _a.config, percentage = config.percentage, message = config.message, label = parseInt(percentage) + '%', barStyle = { width: label };
        return createElement("div", { className: 'container' },
            createElement("div", { className: "Dialog Progress" },
                createElement("div", { className: 'content' }, message),
                createElement("div", { className: 'bar meter' },
                    createElement("span", { style: barStyle }, percentage <= 100 ? label : ''))),
            createElement("div", { className: "DialogMask" }));
    };
    Progress = __decorate([
        withUIEvents
    ], Progress);
    return Progress;
}(Component));
function createUI$1(store) {
    var connect$$1 = store.connect, modelId = store.getModelIdByClass(Tools);
    return connect$$1(function (s) {
        var tools = s[modelId];
        return {
            dialogs: tools.dialogs,
            progress: tools.progress
        };
    })(ToolsUI);
}

/**
 * Tools plugin provides common functions, it needs to work together with ToolsUI component
 */
var Tools = /** @class */ (function (_super) {
    __extends(Tools, _super);
    function Tools() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.dialogs = [];
        _this.progress = { percentage: -1, message: '' };
        return _this;
    }
    /** a resuable effect to open a dialog, returns the index of the button clicked */
    Tools.prototype.showDialog = function (dialog) {
        return __awaiter(this, void 0, void 0, function () {
            var ret;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.events().run(function (id) {
                            //onstart will be called immediately with an auto generated id
                            dialog.id = id; //the transaction id, UI Component uses the id to return value via events.solve
                            _this.addDialog(dialog); //call reducer to change state which will change UI
                        })]; //finishes after Component calls the events.solve(id,value)
                    case 1:
                        ret = _a.sent() //finishes after Component calls the events.solve(id,value)
                        ;
                        this.removeDialog(dialog); //reducer to remove the dialog
                        return [2 /*return*/, ret]; //this is the value from UI
                }
            });
        });
    };
    Tools.prototype.addDialog = function (dialog) {
        this.dialogs.push(dialog);
    };
    Tools.prototype.removeDialog = function (dialog) {
        this.dialogs = this.dialogs.filter(function (a) { return a.id !== dialog.id; });
    };
    Tools.prototype.sleep = function (ms) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, new Promise(function (solve) {
                            setTimeout(solve, ms);
                        })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Tools.prototype.showProgress = function (progress) {
        Object.assign(this.progress, progress);
    };
    Tools.prototype.onModelInstalled = function (store, dispatch, modelId) {
        store.pluginUIs.push(createUI$1(store));
    };
    __decorate([
        effect,
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", Promise)
    ], Tools.prototype, "showDialog", null);
    __decorate([
        effect,
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Number]),
        __metadata("design:returntype", Promise)
    ], Tools.prototype, "sleep", null);
    return Tools;
}(Plugin));

var plugins = { Loading: Loading, Logging: Logging, Tools: Tools };

export { index as router, plugins, effect, singleEffect, computed, middleware, Model, Plugin, UIEvents, createStore$1 as createStore, withUIEvents };
//# sourceMappingURL=service-store.es5.js.map
