import * as React from 'react';
import { RouteManager, PathTest } from './core';
declare type Actions = 'WillEnter' | 'Enter' | 'WillLeave' | 'Leave' | '';
interface FolderProp {
    test: PathTest;
    className?: string;
    transitionDuration?: number;
    manager?: RouteManager;
    path?: string;
}
interface FolderState {
    show: boolean;
    action: Actions;
    props: any;
    firstRender: boolean;
    mounted: boolean;
}
declare class Folder extends React.PureComponent<FolderProp> {
    static defaultProps: Partial<FolderProp>;
    state: FolderState;
    static getDerivedStateFromProps(props: FolderProp, state: FolderState): FolderState | {
        show: boolean;
        action: string;
        props: FolderProp;
        firstRender: boolean;
    };
    render(): JSX.Element;
    timers: any[];
    clearTimer(): any[];
    componentDidUpdate(): void;
    componentDidMount(): void;
    componentWillUnmount(): void;
}
export { Folder };
