interface History {
    current: string;
    push(path: string): void;
    replace(path: string): void;
    go(change: number): void;
    goBack(): void;
    goForward(): void;
    addHandler(handler: Function): History;
    removeHandler(handler: Function): History;
    fire(): void;
    redirects: {
        [key: string]: string;
    };
}
declare class HashHistory implements History {
    readonly current: string;
    push(path: string): void;
    replace(path: string): void;
    go(change: number): void;
    goBack(): void;
    goForward(): void;
    handlers: any[];
    onChange: () => void;
    handlerChanged(): void;
    redirects: {};
    addHandler(handler: (path: string) => void): this;
    removeHandler(handler: (path: string) => void): this;
    fire(): void;
}
export { History, HashHistory };
