import * as React from 'react';
import { History } from './History';
declare const PathProvier: React.ComponentType<React.ProviderProps<string>>;
declare const ManagerProvier: React.ComponentType<React.ProviderProps<RouteManager>>;
declare function withPath(Component: any): any;
declare function withManager(Component: any): any;
/**
 * return true|false for a path and a test
 * @param path
 * @param test
 */
declare function match(path: string, test: PathTest): boolean;
declare type PathTest = string | RegExp | ((path: string) => boolean);
interface Direction {
    reverse: boolean;
}
declare type RouteManager = {
    history: History;
    getDirection: (oldPath: string, newPath: string) => Direction;
    redirects: {
        [path: string]: string;
    };
    skipAnimation: string[];
};
export { PathProvier, withPath, ManagerProvier, withManager, RouteManager, match, PathTest };
