import * as React from 'react';
import { Store } from 'redux';
import { UIEvents } from './core';
declare class Effect {
    id: string;
    actionType: string;
    parent: Effect;
    constructor(id: string, actionType: string);
    children: Effect[];
    startTime: number;
    finishTime: number;
    start(): void;
    finish(): void;
    onStart(): void;
    onFinish(): void;
    cancel(): void;
}
/**
 * convert class to redux state & action
 * @param cls
 * @param modelId
 */
declare class ServiceStore<T> {
    models: T;
    /**
     * the redux store instance
     */
    store: Store;
    private dispatcher;
    private computedFields;
    events: UIEvents;
    effects: Effect[];
    private getEffect;
    private getEffectById;
    private getEffectByActionType;
    private removeEffect;
    private getEffectRoot;
    private getEffectRootId;
    private hasEffect;
    private createEffect;
    private modelHelper;
    constructor(models: T, middleware?: any[], reducer?: Function);
    /**
     * return the targetting model of the action
     * @param actionType
     */
    getModelByActionType(actionType: string): any;
    getModelIdByClass(actionType: any): string;
    readonly dispatch: T;
    dispatchPool: {
        [effectId: string]: any;
    };
    getEffectDispatch(effectId: any): any;
    /**
     * root state, doesn't feel very useful?
     */
    readonly state: T;
    /**
     * connect decorator to use with React.Component.
     * it maps state (or calcudated fields) to component props
     */
    readonly connect: (stateMap: (state: T) => object) => (method: any) => any;
    _lastState: any;
    _lastMergedState: any;
    private getMergedState;
    pluginUIs: any[];
    readonly Provider: (props: any) => React.ReactElement<React.ProviderProps<UIEvents>>;
    getService: (name: string) => any;
}
declare function createStore<T>(models: T, middlewares?: Function[], reducer?: Function): ServiceStore<T>;
declare function withUIEvents(Component: any): any;
export { createStore, withUIEvents };
