import { Plugin } from '../core';
/**
 * Tools plugin provides common functions, it needs to work together with ToolsUI component
 */
declare class Tools extends Plugin {
    dialogs: any[];
    progress: {
        percentage: number;
        message: string;
    };
    /** a resuable effect to open a dialog, returns the index of the button clicked */
    showDialog(dialog: Dialog): Promise<{}>;
    private addDialog;
    private removeDialog;
    sleep(ms: number): Promise<void>;
    showProgress(progress: Partial<{
        percentage: number;
        message: string;
    }>): void;
    onModelInstalled(store: any, dispatch: Tools, modelId: string): void;
}
interface Dialog {
    id?: string;
    message: string;
    title?: string;
    buttons?: string[];
}
export { Tools };
