import * as React from 'react';
declare type Actions = 'WillEnter' | 'Enter' | 'WillLeave' | 'Leave' | '';
interface CompInfo {
    comp: JSX.Element;
    action: Actions;
}
interface TransitionProp {
    component?: JSX.Element;
    transitionDuration?: number;
    getClassName?: (action: string) => string;
    transFirst?: boolean;
    injectClass?: boolean;
}
interface TransitionState {
    components: CompInfo[];
    props: any;
}
declare class Transition extends React.PureComponent<TransitionProp, TransitionState> {
    static defaultProps: Partial<TransitionProp>;
    state: TransitionState;
    static getDerivedStateFromProps(props: TransitionProp, state: TransitionState): TransitionState | {
        components: {
            comp: JSX.Element;
            action: string;
        }[];
        props: TransitionProp;
    };
    render(): JSX.Element;
    startAnimation(): void;
    fnishAnimation(): void;
    timers: any[];
    clearTimer(): any[];
    componentDidUpdate(): void;
    componentDidMount(): void;
    checkAnimation(): void;
    componentWillUnmount(): void;
}
export { Transition };
